#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var child_process_1 = require("child_process");
var inquirer_1 = require("inquirer");
var create_1 = require("./create");
var CREATE_NEW_ONE = {
    name: 'I want to create new emulator',
    value: (new Date()).toLocaleString(),
};
var launch = function (name) {
    if (!name) {
        return init();
    }
    var processCount = child_process_1.execSync("ps aux | grep \"\\-avd " + name + "\" | wc -l").toString();
    if (Number(processCount) >= 3) {
        console.log("Android emulator " + name + " had been launched");
    }
    else {
        console.log("Android emulator " + name + " is launching now...");
        child_process_1.execSync("cd $ANDROID_HOME/tools && emulator -avd " + name + " &", {
            stdio: 'inherit',
        });
    }
};
var init = function () {
    var avds = child_process_1.execSync('emulator -list-avds')
        .toString()
        .split('\n')
        .filter(Boolean);
    if (!avds.length) {
        create_1.createEmulator().then(launch);
    }
    else {
        inquirer_1.createPromptModule()({
            type: 'list',
            name: 'avd',
            message: 'Select an android emulator you want to launch:',
            choices: avds.map(function (avd) { return ({
                name: avd,
                value: avd,
            }); }).concat([CREATE_NEW_ONE]),
            prefix: '',
            suffix: '',
        }).then(function (_a) {
            var avd = _a.avd;
            if (avd === CREATE_NEW_ONE.value) {
                create_1.createEmulator().then(launch);
            }
            else {
                launch(avd);
            }
        });
    }
};
init();
